package reborncore.mcmultipart.client.multipart;

import java.util.HashMap;
import java.util.Map;

import reborncore.mcmultipart.multipart.MultipartRegistry;
import net.minecraft.block.Block;
import net.minecraft.block.properties.IProperty;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.renderer.block.model.ModelResourceLocation;
import net.minecraft.client.renderer.block.statemap.DefaultStateMapper;
import net.minecraft.client.renderer.block.statemap.IStateMapper;
import net.minecraft.util.ResourceLocation;

public class MultipartStateMapper extends DefaultStateMapper {

    public static MultipartStateMapper instance = new MultipartStateMapper();

    private boolean replaceNormal = true;

    @Override
    public Map<IBlockState, ModelResourceLocation> func_178130_a(Block blockIn) {

        Map<IBlockState, ModelResourceLocation> mappings = new HashMap<IBlockState, ModelResourceLocation>();
        replaceNormal = false;
        mappings.putAll(super.func_178130_a(blockIn));
        replaceNormal = true;

        for (ResourceLocation part : MultipartRegistry.getRegisteredParts()) {
            IStateMapper mapper = MultipartRegistryClient.getSpecialPartStateMapper(part);
            if (mapper != null) {
                mappings.putAll(mapper.func_178130_a(blockIn));
            } else {
                BlockStateContainer state = MultipartRegistry.getDefaultState(part);
                ResourceLocation modelPath = MultipartRegistry.getStateLocation(state);
                for (IBlockState istate : state.func_177619_a())
                    mappings.put(istate, new ModelResourceLocation(modelPath, this.func_178131_a(istate.func_177228_b())));
            }
        }
        return mappings;
    }

    @Override
    public String func_178131_a(Map<IProperty<?>, Comparable<?>> p_178131_1_) {

        String str = super.func_178131_a(p_178131_1_);
        if (replaceNormal && str.equals("normal")) return "multipart";
        return str;
    }

}
