package reborncore.mcmultipart.network;

import reborncore.mcmultipart.MCMultiPartMod;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.server.management.PlayerChunkMap;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraft.world.WorldServer;
import net.minecraftforge.fml.common.network.NetworkRegistry;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.SimpleNetworkWrapper;
import net.minecraftforge.fml.relauncher.Side;

public class MultipartNetworkHandler {

    public static final SimpleNetworkWrapper wrapper = NetworkRegistry.INSTANCE.newSimpleChannel("rc-mp");

    public static void init() {

        wrapper.registerMessage(MessageMultipartChange.class, MessageMultipartChange.class, 0, Side.CLIENT);
        wrapper.registerMessage(MessageWrappedPartPlacement.class, MessageWrappedPartPlacement.class, 1, Side.SERVER);
    }

    public static void sendToAllWatching(IMessage message, World world, BlockPos pos) {

        PlayerChunkMap manager = ((WorldServer) world).func_184164_w();
        for (EntityPlayer player : world.field_73010_i)
            if (manager.func_72694_a((EntityPlayerMP) player, pos.func_177958_n() >> 4, pos.func_177952_p() >> 4))
                wrapper.sendTo(message, (EntityPlayerMP) player);
    }

    public static void sendToServer(IMessage message) {

        wrapper.sendToServer(message);
    }

}
